//Random Cloud Composition (c) Guido Kramann, Potsdam, Germany

//TON    BIT
//D3-D4   7
//+  -

//BIT:
//6      5      4      3
//1      2      3      4    
//D5-D6  D7-D8  D9-D10 D11-D12
//+  -   +  -   +  -   +   -

//BIT:
//2      1      0
//rot    gelb   grün
//A5-A4  A3-A2  A1-A0
//+  -   +  -   +  -
//D23-22 D21-20 D19-18



char c; //Wird bitweise interpretiert: Jedes Bit eine LED, Abfolge s.o.
char taster; //Hilfsvariable zum Erfassen des Tasterzustandes
unsigned char DURCHLAUF = 0;
void verarbeiteC()
{
    //Bit0 - grün
    digitalWrite(19,c%2);
    c=(c>>1);
    //Bit1 - gelb
    digitalWrite(21,c%2);
    c=(c>>1);
    //Bit2 - rot
    digitalWrite(23,c%2);
    c=(c>>1);
    
    //Bit3 - 4
    digitalWrite(11,c%2);
    c=(c>>1);
    //Bit4 - 3
    digitalWrite(9,c%2);
    c=(c>>1);
    //Bit5 - 2
    digitalWrite(7,c%2);
    c=(c>>1);
    //Bit6 - 1
    digitalWrite(5,c%2);
    c=(c>>1);
    
    //Bit7 - TON
    digitalWrite(3,c%2);        
}

void allesAn()
{
    digitalWrite(3,1);
    digitalWrite(4,0);
    digitalWrite(5,1);
    digitalWrite(6,0);
    digitalWrite(7,1);
    digitalWrite(8,0);
    digitalWrite(9,1);
    digitalWrite(10,0);
    digitalWrite(11,1);
    digitalWrite(12,0);  
    digitalWrite(18,0);
    digitalWrite(19,1);
    digitalWrite(20,0);
    digitalWrite(21,1);
    digitalWrite(22,0);
    digitalWrite(23,1);    
}

void allesAus()
{
    digitalWrite(3,0);
    digitalWrite(4,0);
    digitalWrite(5,0);
    digitalWrite(6,0);
    digitalWrite(7,0);
    digitalWrite(8,0);
    digitalWrite(9,0);
    digitalWrite(10,0);
    digitalWrite(11,0);
    digitalWrite(12,0);
    digitalWrite(18,0);
    digitalWrite(19,0);
    digitalWrite(20,0);
    digitalWrite(21,0);
    digitalWrite(22,0);
    digitalWrite(23,0);
}

void setup() 
{
    Serial.begin(9600);
    
    //Taster:
    pinMode(0,INPUT);      
    digitalWrite(0,1); //Pullup-Widerstand
    
    
    pinMode(18,OUTPUT);      
    pinMode(19,OUTPUT);      
    pinMode(20,OUTPUT);      
    pinMode(21,OUTPUT);      
    pinMode(22,OUTPUT);      
    pinMode(23,OUTPUT);      
       
    pinMode(3,OUTPUT);      
    pinMode(4,OUTPUT);      
    
    pinMode(5,OUTPUT);      
    pinMode(6,OUTPUT);      
    pinMode(7,OUTPUT);      
    pinMode(8,OUTPUT);      
    pinMode(9,OUTPUT);      
    pinMode(10,OUTPUT);      
    pinMode(11,OUTPUT);      
    pinMode(12,OUTPUT);              
}

void loop() 
{
  if(DURCHLAUF<3)
  {
    allesAn();
    delay(500);
    allesAus();
    delay(500);
    DURCHLAUF++;
  }
  else if(Serial.available())
  {
       c=Serial.read();
       taster = digitalRead(0); //Tasterzustand einlesen
       if(taster>0)
           Serial.write('0');
       else
           Serial.write('1');       
       verarbeiteC();
  }  
}
